/*****************************************************************************
** DOC3.PRG
**
** ProVision:Windows v1.20 sample from Chapter 3 - OVERVIEW AND QUICKSTART
**
** by J. David Reynolds
**
** Copyright 1991, 1992 SofDesign International, Inc.
** All rights reserved
**
** tab spacing = 3
**
*****************************************************************************/

// Commands and constants are defined in header files
// included by PW.CH.
#include "pw.ch"

FUNCTION Main()
   // Just as with Clipper's GET system, you must
   // declare GetList to hold the window's controls.
   LOCAL GetList := {}
   LOCAL oWnd

   // All ProVision:Windows applications must use
   // this command before almost any other
   // ProVision:Windows command or function.
   INIT WINDOWS

   // This is all there is to creating a simple window.
   // This window is a "primary" window, which means
   // that it is movable and sizable and has scrollbars
   // and the other trappings of a typical window in a
   // windowing environment.
   CREATE WINDOW oWnd ;
      CENTERED ;
      SIZE 12, 40 ;
      STYLE PWSTYLE_PRIMARY - PWSTYLEINFO_MENU

   // Yes, just a normal Clipper @...SAY will be drawn
   // in the newly-created window--even though it's not
   // yet visible!
   @ 02, 00 SAY PADC("Wow, cool!", 37)

   // It's as easy as this to create a pushbutton and
   // attach it to the window.  The action code block
   // for this pushbutton will close the window.
   @ 05, 14 GET AS PUSHBUTTON ;
      PROMPT "  OK  " ;
      ACTION { || oWnd:close() }
   ATTACH CONTROLS TO oWnd

   // After this command, the window will be visible--
   // including the text and the pushbutton that were
   // drawn while it was hidden.
   OPEN WINDOW oWnd

   // At this point, control is turned over to the
   // ProVision:Windows event system.  Everything that
   // happens now is directed by the structure of the
   // application and the actions of the user.
   ACTIVATE WINDOWS

   // Be sure to include this command!  It's most
   // important action is to restore the EGA or VGA font
   // to its state at the time of INIT WINDOWS.
   DEINIT WINDOWS

   RETURN(NIL)

