*************************************************************
* Program.... SAMPLE2.PRG
* Version.... 1.00
* Author..... Jon Cole (American Management Systems)
* Created.... November 1, 1991
* Revisions.. (none)
* Source..... Clipper 5.01, ProVision:Windows v1.20
* Libraries.. CLIPPER.LIB, PWFUNCS.LIB, PWKERNEL.LIB
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Compile.....CLIPPER SAMPLE2 /n /m /w
* Link........RTLINK FI SAMPLE2 LIB PWFUNCS,PWKERNEL
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* This program is placed into the public domain by the
* author.
*************************************************************
#include "inkey.ch"
#include "pw.ch"
//Make these STATIC because other functions use them
STATIC oWnd1, oWnd2
STATIC cName, cAdr, cCity, cState, cZip, cPhone, lType
STATIC nRating
FUNCTION Sample2()
   LOCAL GetList:={}
   LOCAL oOk, oHelp, oQuit, nJ
   // Disable <<Alt>><<C>> and <<Ctrl>><<Break>>
   SET( _SET_CANCEL, .f. )
   // If sample dbf doesn't exist, create it.
   IF .NOT. FILE( "Sample.dbf" )
      MakeSample()
   ENDIF
   // open the dbf
   USE Sample
   // Initialize ProVision:Windows
   INIT WINDOWS ;
      GRAPHIC MOUSE ;
      GRAPHIC BORDERS ;
      GRAPHIC CONTROLS
   // Establish which keys move between fields.
   SET KEY FOR NEXTFIELD TO K_TAB, K_ENTER, K_DOWN
   SET KEY FOR PREVIOUSFIELD TO K_SH_TAB, K_UP
   // Establish which key activates the default action.
   SET KEY FOR DEFAULTACTION TO K_CTRL_ENTER
   // Create the first window
   CREATE WINDOW oWnd1 ;
      AT 2, 10 ;
      SIZE 17, 40 ;
      STYLE PWSTYLE_PRIMARY - PWSTYLEINFO_MENU ;
      TITLE "Main Window" ;
      ICON TITLE "Main" ;
      VIRTUAL SIZE 24, 80 ;
      SHADOW
   // Display and register the window.
   OPEN WINDOW oWnd1
   // Create a second window
   CREATE WINDOW oWnd2 ;
      AT 7, 25 ;
      SIZE 10, 40 ;
      STYLE PWSTYLE_PRIMARY - PWSTYLEINFO_MENU ;
      TITLE "Second Window" ;
      ICON TITLE "Report" ;
      VIRTUAL SIZE 50, 120 ;
      SHADOW
   // Display and register the window.
   OPEN WINDOW oWnd2 BACK
   // Create a series of GETs using an array.
   @  1, 2 GET cName AS TEXTFIELD ;
      INITIAL space(25) PROMPT "~Name   : "
   @  2, 2 GET cAdr AS TEXTFIELD ;
      INITIAL space(25) prompt "~Address: "
   @  3, 2 GET cCity AS TEXTFIELD ;
      INITIAL space(15) PROMPT "~City   : "
   @  4, 2 GET cState AS TEXTFIELD ;
      INITIAL space(2)  PROMPT "~State  : " ;
      PICTURE "!!"
   @  5, 2 GET cZip AS TEXTFIELD ;
      INITIAL space(9)  PROMPT "~Zip    : " ;
      PICTURE "@R 99999-9999"
   @  6, 2 GET cPhone AS TEXTFIELD ;
      INITIAL space(10) PROMPT "~Phone  : " ;
      PICTURE "@R (999) 999-9999"
   @  8, 2 GET lType AS CHECKBOX ;
      INITIAL .f. PROMPT "~Business"
   @  8, 17 GET nRating AS RADIOBUTTONS ;
      INITIAL 2 ;
      PROMPT {"~Important","~Medium","~Unimportant"}
   @ 11,  2 GET AS PUSHBUTTON oOk ;
      PROMPT " ~OK " ACTION { || SaveIt() }
   @ 11, 12 GET AS PUSHBUTTON oQuit ;
      PROMPT "~Quit" ACTION { || Done() }
   @ 11, 22 GET AS PUSHBUTTON oHelp ;
      PROMPT "~Help" ACTION { || MyHelp() }
   // Link all GETs in the GetList array to a specific
   // window.  The GetList is immediately purged.
   // Set a default action
   ATTACH CONTROLS TO oWnd1 DEFAULT ACTION oOk
   // Begin event processing.
   ACTIVATE WINDOWS
   // Terminate event processing.
   DEINIT WINDOWS
   RETURN(NIL)

STATIC FUNCTION MyHelp()
   LOCAL oHelpWnd, oOK, GetList:={}
   // Create a help window
   CREATE WINDOW oHelpWnd ;
      AT   10, 25 ;
      SIZE 10, 39 ;
      TITLE " " ;
      STYLE PWSTYLE_SECONDARY
   // Register & display it.
   OPEN WINDOW oHelpWnd
   // Write text to it.
   @ 0, 0 SAY "This is an example of text help"
   @ 1, 0 SAY "within a window.  It's very simple"
   @ 2, 0 SAY "to accomplish."
   // Create a control.
   @ 4, 14 GET AS PUSHBUTTON PROMPT " ~OK " ;
      ACTION { || oHelpWnd:destroy() }
   // Attach the control to the help window & purge GetList.
   ATTACH CONTROLS TO oHelpWnd
   RETURN(NIL)

STATIC FUNCTION SaveIt()
   LOCAL nJ, oOldWnd
   // Use a static so that each time we write to the window,
   // we can conveniently increment the row.
   STATIC nRow := 0
   // Select the 2nd window for writing.
   // Note: focus has not been removed from oWnd1.
   oOldWnd := pw():setOutput(oWnd2)
   // write to the next row
   nRow++
   // Place cursor at beginning of appropriate row
   DEVPOS( nRow, 0 )
   // Add a blank record to the dbf
   APPEND BLANK
   // Loop through all fields
   REPLACE Sample->Name WITH cName
   REPLACE Sample->Adr WITH cAdr
   REPLACE Sample->City WITH cCity
   REPLACE Sample->State WITH cState
   REPLACE Sample->Zip WITH cZip
   REPLACE Sample->Phone WITH cPhone
   REPLACE Sample->Business WITH lType
   REPLACE Sample->Rating WITH nRating
   FOR nJ := 1 TO FCOUNT()
      // display data in 2nd window
      ?? FIELDGET( nJ )
      ?? "   "
   NEXT nJ
   // write it to disk
   COMMIT
   // select the original window (oWnd1) for writing.
   pw():setOutput( oOldWnd )
   RETURN(nil)

// create Sample.dbf
STATIC FUNCTION MakeSample
   LOCAL aDbfStruc := {}
   // Define the structure for the sample DBF
   AADD( aDbfStruc, { "Name",     "C", 25,   0 })
   AADD( aDbfStruc, { "Adr",      "C", 25,   0 })
   AADD( aDbfStruc, { "City",     "C", 15,   0 })
   AADD( aDbfStruc, { "State",    "C", 2,    0 })
   AADD( aDbfStruc, { "Zip",      "C", 9,    0 })
   AADD( aDbfStruc, { "Phone",    "C", 10,   0 })
   AADD( aDbfStruc, { "Business", "L", 1,    0 })
   AADD( aDbfStruc, { "Rating",   "N", 1,    0 })
   // create the sample dbf.
   DBCREATE( "Sample", aDbfStruc )
   RETURN(nil)

STATIC FUNCTION Done()
   oWnd2:close()
   oWnd1:close()
   RETURN(nil)
